
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Prescription_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const prescription_items = await db.prescription_items.create(
            {
                id: data.id || undefined,
        
        dose_instructions: data.dose_instructions
        ||
        null
            ,
            
        frequency: data.frequency
        ||
        null
            ,
            
        duration_days: data.duration_days
        ||
        null
            ,
            
        quantity_prescribed: data.quantity_prescribed
        ||
        null
            ,
            
        substitution_allowed: data.substitution_allowed
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await prescription_items.setPrescription( data.prescription || null, {
            transaction,
        });
        
        await prescription_items.setMedicine( data.medicine || null, {
            transaction,
        });
        
        await prescription_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return prescription_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const prescription_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                dose_instructions: item.dose_instructions
            ||
            null
            ,
            
                frequency: item.frequency
            ||
            null
            ,
            
                duration_days: item.duration_days
            ||
            null
            ,
            
                quantity_prescribed: item.quantity_prescribed
            ||
            null
            ,
            
                substitution_allowed: item.substitution_allowed
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const prescription_items = await db.prescription_items.bulkCreate(prescription_itemsData, { transaction });

        // For each item created, replace relation files
        

        return prescription_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const prescription_items = await db.prescription_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.dose_instructions !== undefined) updatePayload.dose_instructions = data.dose_instructions;
        
        
        if (data.frequency !== undefined) updatePayload.frequency = data.frequency;
        
        
        if (data.duration_days !== undefined) updatePayload.duration_days = data.duration_days;
        
        
        if (data.quantity_prescribed !== undefined) updatePayload.quantity_prescribed = data.quantity_prescribed;
        
        
        if (data.substitution_allowed !== undefined) updatePayload.substitution_allowed = data.substitution_allowed;
        
        
        updatePayload.updatedById = currentUser.id;

        await prescription_items.update(updatePayload, {transaction});

        
        
        if (data.prescription !== undefined) {
            await prescription_items.setPrescription(
              
              data.prescription,
              
              { transaction }
            );
        }
        
        if (data.medicine !== undefined) {
            await prescription_items.setMedicine(
              
              data.medicine,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await prescription_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return prescription_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const prescription_items = await db.prescription_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of prescription_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of prescription_items) {
                await record.destroy({transaction});
            }
        });


        return prescription_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const prescription_items = await db.prescription_items.findByPk(id, options);

        await prescription_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await prescription_items.destroy({
            transaction
        });

        return prescription_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const prescription_items = await db.prescription_items.findOne(
            { where },
            { transaction },
        );

        if (!prescription_items) {
            return prescription_items;
        }

        const output = prescription_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.reminders_prescription_item = await prescription_items.getReminders_prescription_item({
            transaction
        });
        
        
        
        
        
        
        
        
        output.prescription = await prescription_items.getPrescription({
            transaction
        });
        
        
        output.medicine = await prescription_items.getMedicine({
            transaction
        });
        
        
        output.organizations = await prescription_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.prescriptions,
        as: 'prescription',
        
        where: filter.prescription ? {
          [Op.or]: [
            { id: { [Op.in]: filter.prescription.split('|').map(term => Utils.uuid(term)) } },
            {
              notes: {
                [Op.or]: filter.prescription.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.medicines,
        as: 'medicine',
        
        where: filter.medicine ? {
          [Op.or]: [
            { id: { [Op.in]: filter.medicine.split('|').map(term => Utils.uuid(term)) } },
            {
              medicine_name: {
                [Op.or]: filter.medicine.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.dose_instructions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'prescription_items',
                        'dose_instructions',
                        filter.dose_instructions,
                    ),
                };
            }
            
            if (filter.frequency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'prescription_items',
                        'frequency',
                        filter.frequency,
                    ),
                };
            }
            

            
            

            
            if (filter.duration_daysRange) {
                const [start, end] = filter.duration_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    duration_days: {
                    ...where.duration_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    duration_days: {
                    ...where.duration_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_prescribedRange) {
                const [start, end] = filter.quantity_prescribedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_prescribed: {
                    ...where.quantity_prescribed,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_prescribed: {
                    ...where.quantity_prescribed,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.substitution_allowed) {
                where = {
                    ...where,
                substitution_allowed: filter.substitution_allowed,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.prescription_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'prescription_items',
                        'frequency',
                        query,
                    ),
                ],
            };
        }

        const records = await db.prescription_items.findAll({
            attributes: [ 'id', 'frequency' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['frequency', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.frequency,
        }));
    }

    
};

